Otto
=========

-   Website: https://www.ottoproject.io
-   IRC: `#otto-tool` on Freenode
-   Mailing list: [Google Groups](https://groups.google.com/group/otto-tool)

![Otto](https://cloud.githubusercontent.com/assets/37534/10147078/d400509e-65e0-11e5-9d66-c419914cbcf4.png)

Otto knows how to develop and deploy any application on any cloud platform, all controlled with a single consistent workflow to maximize the productivity of you and your team.

For more information, see the [introduction section](https://www.ottoproject.io/intro)
of the Otto website.

## Key Features

The key features of Otto are:

* **Automatic development environments**: Otto detects your application
  type and builds a development environment tailored specifically for that
  application, with zero or minimal configuration. If your application depends
  on other services (such as a database), it'll automatically configure and
  start those services in your development environment for you.

* **Built for Microservices**: Otto understands dependencies and versioning
  and can automatically deploy and configure an application and all
  of its dependencies for any environment. An application only needs to
  tell Otto its immediate dependencies; dependencies of dependencies are
  automatically detected and configured.

* **Deployment**: Otto knows how to deploy applications as well develop
  them. Whether your application is a modern microservice, a legacy
  monolith, or something in between, Otto can deploy your application to any
  environment.

* **Docker**: Otto can use Docker to download and start dependencies
  for development to simplify microservices. Applications can be containerized
  automatically to make deployments easier without changing the developer
  workflow.

* **Production-hardened tooling**: Otto uses production-hardened tooling to
  build development environments ([Vagrant](https://vagrantup.com)),
  launch servers ([Terraform](https://terraform.io)), configure
  services ([Consul](https://consul.io)), and more. Otto builds on
  tools that powers the world's largest websites.
  Otto automatically installs and manages all of this tooling, so you don't
  have to.

## Getting Started & Documentation

All documentation is available on the [Otto website](https://www.ottoproject.io).

